$INCLUDE "RAPIDQ.INC"
$INCLUDE "RAPIDQ2.INC"
$RESOURCE ICO_CARN AS "M:\CARNIVORES2\CARN2.ICO"
     
DIM SaveDialog AS QFileDialog
DIM OpenDialog AS QOpenDialog

DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadRscFile
DECLARE SUB SaveRscFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture555
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB FileSave
DECLARE SUB StoreBitmap (Z AS INTEGER)
DECLARE SUB RetrieveBitmap (Z AS INTEGER)

DECLARE SUB CanvasPaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
DECLARE SUB DrawTexture (Z AS INTEGER)
DECLARE SUB ShowTexture (Sender AS QMENUITEM)
DECLARE SUB ShowTexture1 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture2 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture3 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture4 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture5 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture6 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture7 (Sender AS QMENUITEM)

DECLARE SUB ExportTGA
DECLARE SUB ImportTGA
DECLARE SUB LoadTGA
DECLARE SUB SaveTGA

DECLARE SUB ExportBMP16
DECLARE SUB ImportBMP16
DECLARE SUB LoadBMP16
DECLARE SUB SaveBMP16

DECLARE SUB ExportBMP32
DECLARE SUB ImportBMP32
DECLARE SUB LoadBMP32
DECLARE SUB SaveBMP32

DECLARE SUB ExportJPG
DECLARE SUB ImportJPG
DECLARE SUB LoadJPG
DECLARE SUB SaveJPG

DECLARE SUB RGBto555

DIM A1& AS INTEGER, B1& AS INTEGER, C1& AS INTEGER, D1& AS INTEGER, E1& AS INTEGER, F1& AS INTEGER, G1& AS INTEGER, H1& AS INTEGER
DIM I1& AS INTEGER, J1& AS INTEGER, K1& AS INTEGER, L1& AS INTEGER, M1& AS INTEGER, N1& AS INTEGER, O1& AS INTEGER, P1& AS INTEGER
DIM Q1& AS INTEGER, R1& AS INTEGER, S1& AS INTEGER, T1& AS INTEGER

DIM BitMap AS QBITMAP
    BitMap.Width = 128
    BitMap.Height = 128
    BitMap.Paint(0,0,0,0)    

DIM XBitMap AS QBITMAPex
    XBitMap.Width = 128
    XBitMap.Height = 128
    XBitMap.Paint(0,0,0,0)    

DIM TextureList AS QBITMAP
    TextureList.Width = 128
    TextureList.Height = 128
    TextureList.Paint(0,0,0,0)    
    
DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM TEX??(127,127)
DIM FileName$ as String
DIM MapFile$ as String
DIM FileType AS SHORT
DIM Q AS SHORT
DIM ROJO AS BYTE
DIM VERDE AS BYTE
DIM AZUL AS BYTE
DIM Indice AS SHORT
DIM TextureSize AS INTEGER
TextureSize=32768
DIM RestOfFile AS STRING * 16*1024*1024
DIM RestOfFileSize AS INTEGER

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM SaveFile AS QMenuItem
    SaveFile.Caption = "&Save File"
    SaveFile.OnClick = FileSave  
    SaveFile.Enabled=False

DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
        
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems OpenFile, SaveFile, ExitPrg
 
DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.Enabled=False
    


DIM SaveAsTGA AS QMenuItem
    SaveAsTGA.Caption = "as 16-bit TGA"
    SaveAsTGA.OnClick = ExportTGA  
    SaveAsTGA.Enabled=True
    
DIM LoadFromTGA AS QMenuItem
    LoadFromTGA.Caption = "from 16-bit TGA"
    LoadFromTGA.OnClick = ImportTGA  
    LoadFromTGA.Enabled=True


DIM SaveAsBMP16 AS QMenuItem
    SaveAsBMP16.Caption = "as 16-bit BMP"
    SaveAsBMP16.OnClick = ExportBMP16  
    SaveAsBMP16.Enabled=True
    
DIM LoadFromBMP16 AS QMenuItem
    LoadFromBMP16.Caption = "from 16-bit BMP"
    LoadFromBMP16.OnClick = importBMP16  
    LoadFromBMP16.Enabled=True
    

DIM SaveAsBMP32 AS QMenuItem
    SaveAsBMP32.Caption = "as 32-bit BMP"
    SaveAsBMP32.OnClick = ExportBMP32  
    SaveAsBMP32.Enabled=True

DIM LoadFromBMP32 AS QMenuItem
    LoadFromBMP32.Caption = "from 24/32-bit BMP"
    LoadFromBMP32.OnClick = ImportBMP32  
    LoadFromBMP32.Enabled=True


DIM LoadFromVarious AS QMenuItem
    LoadFromVarious.Caption = "from image file"
    LoadFromVarious.OnClick = ImportJPG
    LoadFromVarious.Enabled=(NViewLibPresent>0)


DIM SaveAsJPG AS QMenuItem
    SaveAsJPG.Caption = "as JPEG"
    SaveAsJPG.OnClick = ExportJPG  
    SaveAsJPG.Enabled=(NViewLibPresent AND 1)

DIM SaveTexture AS QMenuItem
    SaveTexture.Caption = "&Save"
    SaveTexture.Enabled=True
    SaveTexture.AddItems SaveAsTGA, SaveAsBMP16, SaveAsBMP32, SaveAsJPG

    
DIM LoadTexture AS QMenuItem
    LoadTexture.Caption = "&Replace"
    LoadTexture.Enabled=True
    LoadTexture.AddItems LoadFromTGA, LoadFromBMP16, LoadFromBMP32, LoadFromVarious


DIM TextureMenu AS QMenuItem
    TextureMenu.Caption = "Te&xture"
    TextureMenu.Enabled=False
    TextureMenu.AddItems SaveTexture, Loadtexture

DIM MoreMenu1 AS QMenuItem
    MoreMenu1.Caption = "&More..."
DIM MoreMenu2 AS QMenuItem
    MoreMenu2.Caption = "&More..."
DIM MoreMenu3 AS QMenuItem
    MoreMenu3.Caption = "&More..."
DIM MoreMenu4 AS QMenuItem
    MoreMenu4.Caption = "&More..."
DIM MoreMenu5 AS QMenuItem
    MoreMenu5.Caption = "&More..."
DIM MoreMenu6 AS QMenuItem
    MoreMenu6.Caption = "&More..."
DIM MoreMenu7 AS QMenuItem
    MoreMenu7.Caption = "&More..."

DIM TexturesMenu(256) AS QMENUITEM
FOR CONTADOR=0 TO 255
      TexturesMenu(CONTADOR).Caption = "Texture " + STR$(CONTADOR+1)
      TexturesMenu(CONTADOR).OnClick = ShowTexture7
      IF CONTADOR<224 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture6
      IF CONTADOR<192 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture5
      IF CONTADOR<160 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture4
      IF CONTADOR<128 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture3
      IF CONTADOR<96 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture2
      IF CONTADOR<64 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture1
      IF CONTADOR<32 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture
NEXT CONTADOR
    
CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 128+4+18+20+2+22+4
    Width = 128+4+4
    BorderStyle = 2
    Caption="Carnivores 1/2/Ice Age Textures Viewer -  (C) 2007 by M.A.Ch.F."
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, ShowMenu, TextureMenu
END CREATE    
CREATE Canvas AS QCanvas
    Visible = False
    OnPaint = CanvasPaint
    OnMouseMove=CanvasMouseMove
END CREATE
CREATE Status1 AS QStatusBar
    Enabled = True
    Height = 24
    SimplePanel = True
END CREATE
    Center
  ShowModal
END CREATE

SUB ShowTexture (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex
    DrawTexture(Indice)
END SUB

SUB ShowTexture1 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+32
    DrawTexture(Indice)
END SUB

SUB ShowTexture2 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+64
    DrawTexture(Indice)
END SUB

SUB ShowTexture3 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+96
    DrawTexture(Indice)
END SUB

SUB ShowTexture4 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+128
    DrawTexture(Indice)
END SUB

SUB ShowTexture5 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+160
    DrawTexture(Indice)
END SUB

SUB ShowTexture6 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+192
    DrawTexture(Indice)
END SUB

SUB ShowTexture7 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+224
    DrawTexture(Indice)
END SUB

SUB DrawTexture (Z AS INTEGER)
DIM Destination AS QRECT
DIM Source AS QRECT
Canvas.Visible = False

Form1.Color = 0

WITH Destination
.Left = 0
.Right = 128
.Top = 0
.Bottom = 128
END WITH
WITH Source
.Left = 0
.Right = 128
.Top = 128*Z
.Bottom = .Top + 128
END WITH
Bitmap.CopyRect(Destination, TextureList, Source)
Status1.SimpleText="Texture #"+STR$(Z+1)+" of "+STR$(A1&)

Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True
Form1.ShowModal

END SUB
 

SUB ImportTGA

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "TGA Files (*.tga)|*.tga"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadTGA

      END IF
END SUB

SUB ExportTGA

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "TGA Files (*.tga)|*.tga"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".tga") = 0 THEN FileName$=FileName$+".tga"
    Status1.SimpleText="Exporting "+FileName$
    SaveTGA
      END IF
END SUB

SUB LoadTGA

DIM File AS QFileStream
File.Open(FileName$, fmRead)
IF File.Size<>18+TextureSize THEN SHOWMESSAGE "WARNING: Not an uncompressed 128x128 16-bit TGA 1.0 image!" ':GOTO AbortLoadTGA

Status1.SimpleText="Reading Header..."
Form1.Show
File.Read(TGAidentsize?)
IF TGAidentsize?<>0 THEN SHOWMESSAGE "ID field present.":GOTO AbortLoadTGA
File.Read(TGAcolourmaptype?)
IF TGAcolourmaptype?<>0 THEN SHOWMESSAGE "Wrong colour map type.":GOTO AbortLoadTGA
File.Read(TGAimagetype?)
IF TGAimagetype?<>2 THEN SHOWMESSAGE "Not an RGB image.":GOTO AbortLoadTGA
File.Read(TGAcolourmapstart%)
IF TGAcolourmapstart%<>0 THEN SHOWMESSAGE "First palette entry should be set to 0.":GOTO AbortLoadTGA
File.Read(TGAcolourmaplength%)
IF TGAcolourmaplength%<>0 THEN SHOWMESSAGE "Colour map present.":GOTO AbortLoadTGA
File.Read(TGAcolourmapbits?)
IF TGAcolourmapbits?<>0 THEN SHOWMESSAGE "Should be 0 bits per palette entry.":GOTO AbortLoadTGA
File.Read(TGAxstart%)
IF TGAxstart%<>0 THEN SHOWMESSAGE "X origin should be 0.":GOTO AbortLoadTGA
File.Read(TGAystart%)
IF TGAystart%<>0 THEN SHOWMESSAGE "Y origin should be 0.":GOTO AbortLoadTGA
File.Read(TGAwidth%)
IF TGAwidth%<>128 THEN SHOWMESSAGE "Image isn't 128 pixels wide.":GOTO AbortLoadTGA
File.Read(TGAheight%)
IF TGAheight%<>128 THEN SHOWMESSAGE "Image isn't 128 pixels tall.":GOTO AbortLoadTGA
File.Read(TGAbits?)
IF TGAbits?<>16 THEN SHOWMESSAGE "Not a 16-bit image.":GOTO AbortLoadTGA
File.Read(TGAdescriptor?)
IF TGAdescriptor?<>0 THEN SHOWMESSAGE "Image is flipped or has alpha bits set.":GOTO AbortLoadTGA
Status1.SimpleText="Reading scanlines..."
Form1.Show

FOR X = 0 TO 127
File.LoadArray(TEX??(128 -X -1, 0),128)
NEXT X
InitScreen
StoreBitmap(Indice)

Status1.SimpleText="Done"
AbortLoadTGA:
Form1.Show
File.Close



END SUB

SUB SaveTGA

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
TGAidentsize?=0:File.Write(TGAidentsize?)
TGAcolourmaptype?=0:File.Write(TGAcolourmaptype?)
TGAimagetype?=2:File.Write(TGAimagetype?)
TGAcolourmapstart%=0:File.Write(TGAcolourmapstart%)
TGAcolourmaplength%=0:File.Write(TGAcolourmaplength%)
TGAcolourmapbits?=0:File.Write(TGAcolourmapbits?)
TGAxstart%=0:File.Write(TGAxstart%)
TGAystart%=0:File.Write(TGAystart%)
TGAwidth%=128:File.Write(TGAwidth%)
TGAheight%=128:File.Write(TGAheight%)
TGAbits?=16:File.Write(TGAbits?)
TGAdescriptor?=0:File.Write(TGAdescriptor?)
Status1.SimpleText="Writing scanlines..."
Form1.Show
RGBto555
FOR X = 0 TO 127
File.SaveArray(TEX??(128 -X -1, 0),128)
NEXT X

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB

SUB ExportBMP16

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
    Status1.SimpleText="Exporting "+FileName$
    SaveBMP16
  END IF
END SUB

SUB SaveBMP16

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
BMSignature$="BM":File.WriteStr(BMSignature$,2)
BMFileSize&=&H36+TextureSize:File.Write(BMFileSize&)
BMreserved&=0:File.Write(BMreserved&)
BMDataOffset&=&H36:File.Write(BMDataOffset&)
BMSize&=&H28:File.Write(BMSize&)
BMWidth&=128:File.Write(BMWidth&)
BMHeight&=128:File.Write(BMHeight&)
BMPlanes%=1:File.Write(BMPlanes%)
BMBitCount%=16:File.Write(BMBitCount%)
BMCompression&=0:File.Write(BMCompression&)
BMImageSize&=0:File.Write(BMImageSize&)
BMXpixelsPerM&=1:File.Write(BMXpixelsPerM&)
BMYpixelsPerM&=1:File.Write(BMYpixelsPerM&)
BMColorsUsed&=&H1000000:File.Write(BMColorsUsed&)
BMColorsImportant&=0:File.Write(BMColorsImportant&)
Status1.SimpleText="Writing scanlines..."
Form1.Show

RGBto555
FOR X = 0 TO 127
File.SaveArray(TEX??(128 -X -1, 0),128)
NEXT X

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB


SUB ImportBMP16

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMP16
  END IF
END SUB

SUB LoadBMP16

DIM File AS QFileStream
File.Open(FileName$, fmRead)
Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMP16
File.Read(BMFileSize&)
IF BMFileSize&<>&H36+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMP16
File.Read(BMreserved&)
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMP16
File.Read(BMDataOffset&)
IF BMDataOffset&<>&H36 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMP16
File.Read(BMSize&)
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMP16
File.Read(BMWidth&)
IF BMWidth&<>128 THEN SHOWMESSAGE "BMP isn't 128 pixels wide.":GOTO AbortLoadBMP16
File.Read(BMHeight&)
IF BMHeight&<>128 THEN SHOWMESSAGE "BMP isn't 128 pixels tall.":GOTO AbortLoadBMP16
File.Read(BMPlanes%)
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMP16
File.Read(BMBitCount%)
IF BMBitCount%<>16 THEN SHOWMESSAGE "BMP doesn't have a 16-bit color depth.":GOTO AbortLoadBMP16
File.Read(BMCompression&)
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMP16
File.Read(BMImageSize&)
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMP16
File.Read(BMXpixelsPerM&)
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMP16
File.Read(BMYpixelsPerM&)
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMP16
File.Read(BMColorsUsed&)
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMP16
File.Read(BMColorsImportant&)
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMP16

Status1.SimpleText="Reading scanlines..."
Form1.Show
FOR X = 0 TO 127
File.LoadArray(TEX??(128 -X -1, 0),128)
NEXT X
InitScreen
StoreBitmap(Indice)

Status1.SimpleText="Done"
AbortLoadBMP16:
Form1.Show
File.Close

END SUB


SUB ExportBMP32

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
    Status1.SimpleText="Exporting "+FileName$
    SaveBMP32
  END IF
END SUB

SUB SaveBMP32

BitMap.SaveToFile(FileName$)

Status1.SimpleText="Done"
Form1.Show

END SUB


SUB ImportBMP32

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMP32
  END IF
END SUB

SUB LoadBMP32

DIM File AS QFileStream
File.Open(FileName$, fmRead)
Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
File.Read(BMFileSize&)
File.Read(BMreserved&)
File.Read(BMDataOffset&)
File.Read(BMSize&)
File.Read(BMWidth&)
File.Read(BMHeight&)
File.Read(BMPlanes%)
File.Read(BMBitCount%)
File.Read(BMCompression&)
File.Read(BMImageSize&)
File.Read(BMXpixelsPerM&)
File.Read(BMYpixelsPerM&)
File.Read(BMColorsUsed&)
File.Read(BMColorsImportant&)
File.close

IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMP32
'IF BMFileSize&<>&H36+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMP32
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMP32
IF BMDataOffset&<>&H36 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMP32
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMP32
IF BMWidth&<>128 THEN SHOWMESSAGE "BMP isn't 128 pixels wide.":GOTO AbortLoadBMP32
IF BMHeight&<>128 THEN SHOWMESSAGE "BMP isn't 128 pixels tall.":GOTO AbortLoadBMP32
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMP32
'IF BMBitCount%<>32 AND BMBitCount%<>24 THEN SHOWMESSAGE "BMP doesn't have a 24- or 32-bit color depth.":GOTO AbortLoadBMP32
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMP32
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMP32
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMP32
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMP32
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMP32
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMP32

Status1.SimpleText="Reading scanlines..."
Form1.Show
BitMap.LoadFromFile(FileName$)
RGBto555
InitScreen
StoreBitmap(Indice)

Status1.SimpleText="Done"
AbortLoadBMP32:
Form1.Show

END SUB



SUB ExportJPG

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "JPEG Files (*.jpg)|*.jpg"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
      FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".jpg") = 0 THEN FileName$=FileName$+".jpg"
    Status1.SimpleText="Exporting "+FileName$
    SaveJPG
  END IF
END SUB

SUB SaveJPG

XBitMap.Height=128
XBitMapWidth=128

XBitMap.BMP=BitMap.BMP
XBitMap.SaveAsJpg(FileName$,100)

Status1.SimpleText="Done"
Form1.Show

END SUB


SUB ImportJPG

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "Picture files|*.BMP;*.ICO;*.JPG;*.GIF;*.DIB;*.RLE;*.TGA;*.PCX"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadJPG
  END IF
END SUB


SUB LoadJPG

Status1.SimpleText="Reading image..."
Form1.Show
XBitMap.LoadOtherImage(FileName$,True,"English")
IF XbitMap.Width<>128 THEN SHOWMESSAGE "image isn't 128 pixels wide.":GOTO AbortLoadJPG
IF XBitMap.Height<>128 THEN SHOWMESSAGE "image isn't 128 pixels tall.":GOTO AbortLoadJPG
Status1.SimpleText="Processing image..."
Form1.Show

Canvas.Draw(0,0,XBitMap.BMP)
BitMap.BMP=XBitMap.BMP
RGBto555
InitScreen
StoreBitmap(Indice)

Status1.SimpleText="Done"
AbortLoadJPG:
Form1.Show

END SUB


SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
    Canvas.Hint=""
    Canvas.Hint=STR$(X)+","+STR$(Y)
END SUB      

SUB CanvasPaint
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)

    CREATE RectArea as QRect
     Top=0
     Left=0
     Right=W
     Bottom=H
    END CREATE
    Canvas.Draw(0,0, Bitmap.BMP)
END SUB

SUB FileOpen
'  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "RSC Files (*.rsc)|*.rsc"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Viewing "+FileName$
    LoadRscFile
'    ShowMenu.Enabled=True
      END IF
END SUB

SUB FileSave
'  DIM OpenDialog AS QOpenDialog

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "RSC Files (*.rsc)|*.rsc"

  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(LCASE$(FileName$),".rsc") = 0 THEN FileName$=FileName$+".rsc"
    Status1.SimpleText="Saving "+FileName$
    SaveRscFile
'    ShowMenu.Enabled=True
   END IF

END SUB
     


SUB ExitClick
  Form1.Close
END SUB  


SUB LoadRscFile

ShowMenu.Enabled=False
TextureMenu.Enabled=False
FOR CONTADOR=MoreMenu7.Count TO 1 STEP -1
MoreMenu7.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu6.Count TO 1 STEP -1
MoreMenu6.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu5.Count TO 1 STEP -1
MoreMenu5.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu4.Count TO 1 STEP -1
MoreMenu4.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu3.Count TO 1 STEP -1
MoreMenu3.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu2.Count TO 1 STEP -1
MoreMenu2.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu1.Count TO 1 STEP -1
MoreMenu1.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=ShowMenu.Count TO 1 STEP -1
ShowMenu.DelIndex(CONTADOR-1)
NEXT CONTADOR

DIM File AS QFileStream
MapFile$=LEFT$(FileName$, RINSTR(FileName$,"."))+"map"
'PRINT MapFile$
IF FILEEXISTS(MapFile$)=0 THEN SHOWMESSAGE "Associated .map file not found!":GOTO AbortLoadRsc
File.Open(MapFile$, fmOpenRead)
IF File.Size=&H220000 THEN
    FileType=1
ELSE   
    IF File.Size=&HD80000 THEN
        FileType=2
    ELSE
        FileType=0
    END IF
END IF
'PRINT FileType
File.Close
IF FileType=0 THEN SHOWMESSAGE "Associated .map file doesn't seem to be a Carnivores file!": GOTO AbortLoadRsc
File.Open(FileName$, fmOpenRead)
'IF File.Size=&H220000 THEN
Status1.SimpleText="Reading Header Data..."
Form1.Show
File.Read(A1&)
File.Read(B1&)
File.Read(C1&)
File.Read(D1&)
File.Read(E1&)
File.Read(F1&)
File.Read(G1&)
File.Read(H1&)

IF FileType=2 THEN
File.Read(I1&)
File.Read(J1&)
File.Read(K1&)
File.Read(L1&)

File.Read(M1&)
File.Read(N1&)
File.Read(O1&)
File.Read(P1&)

File.Read(Q1&)
File.Read(R1&)
File.Read(S1&)
File.Read(T1&)
END IF

'Form1.ClientWidth = 128
'Form1.ClientHeight = 128
Canvas.Width = 128
Canvas.Height = 128
Canvas.ClientWidth = 128
Canvas.ClientHeight = 128
BitMap.Width = 128
BitMap.Height = 128
'Form1.Center
TextureList.Height = 128*A1&
FOR CONTADOR=1 TO A1&
File.LoadArray(TEX??(0, 0),128*128)
'InitScreen
StoreBitmap(CONTADOR-1)
IF CONTADOR<=32 THEN
ShowMenu.AddItems(TexturesMenu(CONTADOR-1))
ELSE
 IF CONTADOR=33 THEN ShowMenu.AddItems(MoreMenu1)
 IF CONTADOR<=64 THEN
 MoreMenu1.AddItems(TexturesMenu(CONTADOR-1))
  ELSE
  IF CONTADOR=65 THEN MoreMenu1.AddItems(MoreMenu2)
  IF CONTADOR<=96 THEN
    MoreMenu2.AddItems(TexturesMenu(CONTADOR-1))
  ELSE
   IF CONTADOR=97 THEN MoreMenu2.AddItems(MoreMenu3)
   IF CONTADOR<=128 THEN
   MoreMenu3.AddItems(TexturesMenu(CONTADOR-1))
   ELSE
    IF CONTADOR=129 THEN MoreMenu3.AddItems(MoreMenu4)
    IF CONTADOR<=160 THEN
        MoreMenu4.AddItems(TexturesMenu(CONTADOR-1))
    ELSE
     IF CONTADOR=161 THEN MoreMenu4.AddItems(MoreMenu5)
     IF CONTADOR<=192 THEN
     MoreMenu5.AddItems(TexturesMenu(CONTADOR-1))
     ELSE
      IF CONTADOR=192 THEN MoreMenu5.AddItems(MoreMenu6)
      IF CONTADOR<=224 THEN
      MoreMenu6.AddItems(TexturesMenu(CONTADOR-1))
      ELSE
       IF CONTADOR=225 THEN MoreMenu6.AddItems(MoreMenu7)
       MoreMenu7.AddItems(TexturesMenu(CONTADOR-1))
      END IF
     END IF
    END IF
   END IF
  END IF
 END IF
END IF
Status1.SimpleText="Texture #"+STR$(CONTADOR)+" of "+STR$(A1&)
Form1.Show
NEXT CONTADOR
ShowMenu.Enabled=True
TextureMenu.Enabled=True
SaveFile.Enabled=True
'ELSE
'Status1.SimpleText="Not a valid Carnivores .map file!"
'Form1.Show
'END IF    

RestOfFileSize=File.Size-File.Position
RestOfFile=File.ReadBinStr(RestOfFileSize)
File.Close
Indice=0
DrawTexture(Indice)

AbortLoadRsc:
END SUB

SUB StoreBitmap (Z AS INTEGER)

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TEX??(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

H = Y: V = X + 128*Z
H1 = Y + 1: V1 = X + 1 + 128*Z
TextureList.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)


NEXT Y: NEXT X


END SUB

SUB InitScreen

Canvas.Visible = False

Form1.Color = 0

DrawPicture555
Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True

END SUB


SUB DrawPicture555


'BitMap.FillRect(0, 0, 128, 128, 0)

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TEX??(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

H = Y: V = X
H1 = Y + 1: V1 = X + 1
BitMap.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)


NEXT Y: NEXT X


END SUB



SUB RGBto555

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = BitMap.Pixel(Y, X)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

TEX??(X, Y) = D

NEXT Y: NEXT X

END SUB


SUB RetrieveBitmap (Z AS INTEGER)

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TextureList.Pixel(Y, X + 128*Z)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

TEX??(X, Y) = D

NEXT Y: NEXT X


END SUB


SUB SaveRscFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
'IF File.Size=&H220000 THEN
Status1.SimpleText="Writing Header Data..."
Form1.Show
File.Write(A1&)
File.Write(B1&)
File.Write(C1&)
File.Write(D1&)
File.Write(E1&)
File.Write(F1&)
File.Write(G1&)
File.Write(H1&)

IF FileType=2 THEN
File.Write(I1&)
File.Write(J1&)
File.Write(K1&)
File.Write(L1&)

File.Write(M1&)
File.Write(N1&)
File.Write(O1&)
File.Write(P1&)

File.Write(Q1&)
File.Write(R1&)
File.Write(S1&)
File.Write(T1&)
END IF

FOR CONTADOR=1 TO A1&
RetrieveBitmap(CONTADOR-1)
File.SaveArray(TEX??(0, 0),128*128)
'InitScreen
Status1.SimpleText="Texture #"+STR$(CONTADOR)+" of "+STR$(A1&)
Form1.Show
NEXT CONTADOR

File.WriteBinStr(RestOfFile,RestOfFileSize)
Status1.SimpleText="File saved."
Form1.Show
AbortSaveRsc:
File.Close
END SUB
